/* eslint-disable vue/require-prop-types */
<!-- eslint-disable vue/require-v-for-key -->
<template>
  <section class="content-bottom clearfix">
    <div class="min-container">
      <div class="tong-quan">
        <div
          class="content-danhgia built-toggle"
          :class="showFullContent == true ? '' : 'has-toggle'"
        >
          <h2 class="title_cate">
            <span>Đánh giá chi tiết</span>
          </h2>

          <div v-if="product.uu_diem" class="flex tong-quan__uudiem">
            <div class="td">
              <p class="medium txt_18 mb24">Ưu điểm</p>
              <!-- eslint-disable-next-line vue/no-v-html -->
              <div v-html="product.uu_diem"></div>
            </div>
            <div v-if="product.nhuoc_diem" class="td nhuoc-diem">
              <p class="medium txt_18 mb24">Nhược điểm</p>
              <!-- eslint-disable-next-line vue/no-v-html -->
              <div v-html="product.nhuoc_diem"></div>
            </div>
          </div>
          <!-- eslint-disable-next-line vue/no-v-html -->
          <div class="rte" v-html="product.content"></div>
        </div>
        <div class="view-full">
          <a
            class="hover-a"
            href="javascript:;"
            @click.prevent="showFullContent = !showFullContent"
          >
            {{ showFullContent ? 'Rút gọn' : 'Xem đầy đủ' }}
          </a>
        </div>
      </div>

      <!-- Box tag -->
      <div v-if="product.tags.length" class="box-tag">
        <h2 class="title">Tags:</h2>
        <h3 v-for="tag in product.tags" :key="tag.name" class="tag-name">
          <a :href="tag.share_url">{{ tag.name }}</a>
        </h3>
      </div>

      <!-- Box Vote -->
      <div
        id="box-vote"
        class="box-vote"
        itemprop="aggregateRating"
        itemtype="http://schema.org/AggregateRating"
        itemscope
      >
        <div class="box-vote__head">
          <div class="flex">
            <div class="vote">
              <h2 class="title_cate">
                <span>Đánh giá của khách hàng</span>
              </h2>
              <div class="flex align-center">
                <span class="number">{{ rate_average || 0 }}</span>
                <ul>
                  <li
                    v-for="star in 5"
                    :key="star"
                    :class="Math.round(rate_average) >= star ? 'active' : ''"
                  >
                    <a
                      v-if="Math.round(rate_average) >= star"
                      href="javascript:;"
                    >
                      <svg-icon
                        name="star-full"
                        class="inline-block align-middle"
                      ></svg-icon>
                    </a>
                    <a v-else href="javascript:;">
                      <svg-icon
                        name="star-none"
                        class="inline-block align-middle"
                      ></svg-icon>
                    </a>
                  </li>
                </ul>
                <a class="line" href="javascript:;">
                  {{ rate_total }} đánh giá
                </a>
              </div>
              <!-- <div class="photograph-user">
                <p class="medium txt_16">Ảnh chụp từ khách hàng</p>
                <ul class="photograph-user__gallery">
                  <li>
                    <a href="#" class="thumb_img thumb_1x1">
                      <img
                        src="/images/graphics/product-desc.jpg"
                        alt="product think"
                      />
                    </a>
                  </li>
                  <li>
                    <a href="#" class="thumb_img thumb_1x1">
                      <img
                        src="/images/graphics/product-desc.jpg"
                        alt="product think"
                      />
                    </a>
                  </li>
                  <li>
                    <a href="#" class="thumb_img thumb_1x1">
                      <img
                        src="/images/graphics/product-desc.jpg"
                        alt="product think"
                      />
                    </a>
                  </li>
                  <li>
                    <a href="#" class="thumb_img thumb_1x1">
                      <img
                        src="/images/graphics/product-desc.jpg"
                        alt="product think"
                      />
                    </a>
                  </li>
                  <li>
                    <a href="#" class="thumb_img thumb_1x1">
                      <img
                        src="/images/graphics/product-desc.jpg"
                        alt="product think"
                      />
                    </a>
                  </li>
                  <li>
                    <a href="#" class="thumb_img thumb_1x1">
                      <img
                        src="/images/graphics/product-desc.jpg"
                        alt="product think"
                      />
                    </a>
                  </li>
                  <li class="last-count">
                    <a href="#" class="thumb_img thumb_1x1">
                      <img
                        src="/images/graphics/product-desc.jpg"
                        alt="product think"
                      />
                      <span class="count">+18</span>
                    </a>
                  </li>
                </ul>
              </div> -->
              <meta itemprop="reviewCount" content="100" />
              <meta itemprop="ratingValue" content="4.9" />
            </div>
            <div class="vote-chart">
              <a
                class="btn-default color-white full mb16"
                href="javascript:;"
                @click.prevent="openRatePopup"
              >
                Viết đánh giá
              </a>
              <!-- @click.prevent="openRatePopup" -->
              <!-- <ul>
                <li>
                  <span class="number">5</span>
                  <div class="chart">
                    <span class="chart_80"></span>
                  </div>
                </li>
                <li>
                  <span class="number">4</span>
                  <div class="chart">
                    <span class="chart_60"></span>
                  </div>
                </li>
                <li>
                  <span class="number">3</span>
                  <div class="chart">
                    <span class="chart_30"></span>
                  </div>
                </li>
                <li>
                  <span class="number">2</span>
                  <div class="chart">
                    <span class="chart_10"></span>
                  </div>
                </li>
                <li>
                  <span class="number">1</span>
                  <div class="chart">
                    <span class="chart_5"></span>
                  </div>
                </li>
              </ul> -->
            </div>
          </div>
        </div>

        <div id="list-comments" class="list-comments">
          <div
            v-for="(rate, index) in rates"
            :key="index"
            class="list-comments__items"
          >
            <div v-if="rate.created_user.avatar" class="ava">
              <img
                :src="
                  resizeImage(baseImageUrl + rate.created_user.avatar, 100, 100)
                "
              />
            </div>
            <div v-else class="ava ava-text">
              {{ getFirstCharter(rate.created_user.name) }}
            </div>
            <div class="comment_mini">
              <h3 class="name">
                <ul>
                  <li
                    v-for="star in 5"
                    :key="star"
                    :class="rate.stars >= star ? 'active' : ''"
                  >
                    <svg-icon
                      v-if="rate.stars >= star"
                      name="star-full"
                      class="inline-block align-middle"
                    ></svg-icon>
                    <svg-icon
                      v-else
                      name="star-none"
                      class="inline-block align-middle"
                    ></svg-icon>
                  </li>
                </ul>
                {{ rate.created_user.name }}
              </h3>
              <p>{{ rate.content }}</p>
              <div class="reply">
                <!-- <a
                  class="reply_a"
                  href="javascript:;"
                  @click="isReply = rate.id"
                >
                  Trả lời
                </a> -->
                <span class="date">{{ rate.created_at }}</span>
              </div>
            </div>
            <!-- <div class="comment_reply">
              <div class="list-comments__items">
                <div class="ava">
                  <img src="/images/graphics/Avatar.png" alt />
                </div>
                <div class="comment_mini">
                  <h3 class="name">ThinkPro</h3>
                  <p>
                    Máy này dùng k có gì để chê cả. Chơi game bao mượt luôn.
                    Nhưng mới mua trả góp cho người yêu.
                  </p>
                  <div class="reply">
                    <a class="reply_a" href="#">Trả lời</a>
                    <span class="date">2 tháng trước</span>
                  </div>
                  <div class="comment_textarea">
                    <textarea
                      id="js_feed_comment_form_textarea_246"
                      rows="1"
                      name="val[text]"
                      class="js_comment_feed_textarea"
                      placeholder="Mời bạn để lại đánh giá"
                    ></textarea>
                    <button href="javascript:;" class="btn submit-comment">
                      Gửi
                    </button>
                  </div>
                </div>
              </div>
            </div> -->
          </div>
        </div>

        <div v-if="rate_links.next" class="view-more view-more__border">
          <a href="javascript:;" @click.prevent="getRates(rate_links.next)">
            Xem Thêm Đánh giá
          </a>
        </div>
      </div>

      <!-- Box Comment -->
      <div id="box-comment" class="box-comment">
        <h2 class="title_cate">
          <span>Bình luận</span>
          <span class="count">{{ meta.total }} bình luận</span>
        </h2>
        <div class="list-comments">
          <p class="txt_16">
            <strong>Bình luận của bạn</strong>
          </p>
          <div class="comment_textarea">
            <textarea
              id="js_feed_comment_form_textarea_246"
              v-model="commentContent"
              rows="1"
              name="val[text]"
              class="js_comment_feed_textarea"
              placeholder="Mời bạn để lại bình luận"
            ></textarea>
            <button
              href="javascript:;"
              class="btn submit-comment"
              @click="addCommentIt(null, commentContent)"
            >
              Gửi
            </button>
          </div>
          <div
            v-for="comment in comments"
            :key="comment.id"
            class="list-comments__items"
          >
            <div v-if="comment.created_user.avatar !== null" class="ava">
              <img
                :src="
                  resizeImage(
                    baseImageUrl + comment.created_user.avatar,
                    100,
                    100
                  )
                "
              />
            </div>
            <div v-else class="ava ava-text">
              {{ getFirstCharter(comment.created_user.name) }}
            </div>
            <div class="comment_mini">
              <h3 class="name">{{ comment.created_user.name }}</h3>
              <p>{{ comment.content }}</p>
              <div class="reply">
                <a
                  v-if="comment.id"
                  class="reply_a"
                  href="javascript:;"
                  @click="isReply = comment.id"
                >
                  Trả lời
                </a>
                <span class="date">{{ comment.created_at }}</span>
              </div>
              <div v-show="isReply == comment.id" class="comment_textarea">
                <textarea
                  id="js_feed_comment_form_textarea_246"
                  rows="1"
                  name="val[text]"
                  class="js_comment_feed_textarea"
                  placeholder="Mời bạn để lại bình luận"
                ></textarea>
                <button
                  class="btn submit-comment"
                  @click.prevent="commentIt(comment.id, $event)"
                >
                  Gửi
                </button>
              </div>
            </div>
            <div class="comment_reply">
              <div
                v-for="child in comment.children"
                :key="child.id"
                class="list-comments__items"
              >
                <div class="list-comments__items">
                  <div v-if="child.created_user.avatar !== null" class="ava">
                    <img
                      :src="
                        resizeImage(
                          baseImageUrl + child.created_user.avatar,
                          100,
                          100
                        )
                      "
                    />
                  </div>
                  <div v-else class="ava ava-text">
                    {{ getFirstCharter(child.created_user.name) }}
                  </div>
                  <div class="comment_mini">
                    <h3 class="name">{{ child.created_user.name }}</h3>
                    <p>{{ child.content }}</p>
                    <div class="reply">
                      <a
                        v-if="child.id"
                        class="reply_a"
                        href="javascript:;"
                        @click="isReply = child.id"
                      >
                        Trả lời
                      </a>
                      <span class="date">{{ child.created_at }}</span>
                    </div>
                    <div v-show="isReply == child.id" class="comment_textarea">
                      <textarea
                        rows="1"
                        name="val[text]"
                        class="js_comment_feed_textarea"
                        placeholder="Mời bạn để lại bình luận"
                      ></textarea>
                      <button
                        class="btn submit-comment"
                        @click.prevent="commentIt(comment.id, $event)"
                      >
                        Gửi
                      </button>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div v-if="links.next" class="view-more view-more__border">
          <a href="javascript:;" @click.prevent="getComments(links.next)">
            Xem thêm bình luận
          </a>
        </div>
      </div>
    </div>

    <Modal>
      <div slot="body">
        <Rate
          :product-shared-url="product.shared_url"
          :add-rate="(content, stars) => addRate(content, stars)"
        />
      </div>
    </Modal>

    <ModalNotifi :width="350">
      <div slot="header">
        <div>Thông báo</div>
      </div>
      <div slot="body">
        <div>{{ errors }}</div>
      </div>
    </ModalNotifi>
  </section>
</template>

<script>
import Helper from '../../../assets/config'
import { EventBus } from '~/plugins/bus'

export default {
  name: 'ProductDetailContent',
  components: {
    Rate: () => import('~/components/Popup/Rate'),
    Modal: () => import('~/components/Popup/Modal'),
    ModalNotifi: () => import('~/components/Popup/ModalNotifi'),
  },
  // eslint-disable-next-line vue/require-prop-types
  props: [
    'product',
    'comments',
    'addComment',
    'meta',
    'links',
    'getComments',
    'rates',
    'rate_meta',
    'rate_links',
    'rate_total',
    'rate_average',
    'getRates',
    'addRate',
  ],
  data() {
    return {
      isShowModal: false,
      isReply: null,
      commentContent: null,
      showFullContent: false,
      errors: '',
    }
  },
  computed: {
    baseImageUrl() {
      return Helper.baseImageUrl
    },
  },
  mounted() {},
  methods: {
    openRatePopup() {
      this.$auth.loggedIn
        ? EventBus.$emit('open-modal', true)
        : EventBus.$emit('open-modal-login', true)
    },
    resizeImage(url, width, height) {
      return Helper.resizeImage(url, width, height)
    },
    addCommentIt(parent_id = null, content) {
      if (this.$auth.loggedIn) {
        if (content != null) {
          this.addComment(content, parent_id)
          this.commentContent = ''
        } else {
          this.errors = 'Bạn chưa nhập nội dung bình luận.'
          EventBus.$emit('open-modalnoti', true)
        }
      } else {
        EventBus.$emit('open-modal-login', true)
      }
    },
    commentIt(parent_id = null, e) {
      let content = e.target.previousElementSibling.value
      if (this.$auth.loggedIn) {
        if (content !== '') {
          this.addComment(content, parent_id)
        } else {
          this.errors = 'Bạn chưa nhập nội dung bình luận.'
          EventBus.$emit('open-modalnoti', true)
        }
      } else {
        EventBus.$emit('open-modal-login', true)
      }
      e.target.previousElementSibling.value = ''
      content = ''
    },
    rateIt() {},
    getFirstCharter(name) {
      const res = name.split(' ')
      // eslint-disable-next-line no-var
      var string = ''
      res.forEach((element) => {
        string = string + element.charAt(0).toUpperCase()
      })
      string = string.slice(-1)
      return string
    },
  },
}
</script>
